// Copyright 2000-2018 JetBrains s.r.o.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
package com.jetbrains.php.codeInsight.controlFlow;

import com.intellij.openapi.diagnostic.Logger;
import com.intellij.openapi.util.Key;

public class ControlFlowException extends RuntimeException {
  public static final Logger LOG = Logger.getInstance(ControlFlowException.class);
  public static final Key CONTROL_FLOW_TOO_BIG_KEY = new Key("GlobalControlFlowBig!");
  public static final int MAX_FLOW_SIZE = 10000;

  public ControlFlowException(String message) {
    super(message);
  }
}
