// Copyright 2000-2018 JetBrains s.r.o.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
package com.jetbrains.php.lang.psi;

import com.intellij.psi.PsiCodeFragment;
import com.intellij.psi.PsiElement;
import com.jetbrains.php.lang.psi.elements.PhpPsiElement;
import com.jetbrains.php.lang.psi.elements.PhpReference;
import org.jetbrains.annotations.NotNull;

import java.util.Collection;
import java.util.Collections;

public interface PhpExpressionCodeFragment extends PhpFile, PhpPsiElement, PsiCodeFragment {
  /**
   * @return resolved psi elements from {@link #getContext()}
   */
  @NotNull
  default Collection<? extends PsiElement> resolve(@NotNull PhpReference reference) {
    return Collections.emptyList();
  }
}
